#ifndef EFL_GENERATED_EVAS_COMMON_INTERFACE_HH
#define EFL_GENERATED_EVAS_COMMON_INTERFACE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_common_interface.eo.h"
}


namespace evas {

struct common_interface;

}

namespace eo_cxx {

namespace evas {

struct common_interface
{
   /// @brief No description supplied by the EAPI.
   ///
   /// @param ret 
   ///
   Evas * evas_get() const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_COMMON_INTERFACE_INTERFACE);
   }

   operator ::evas::common_interface() const;
   operator ::evas::common_interface&();
   operator ::evas::common_interface const&() const;

   template <typename D>
   struct address_of
   {
      operator ::evas::common_interface*() const { return static_cast<::evas::common_interface*>(static_cast<D const*>(this)->p); }
      operator ::evas::common_interface const*() const { return static_cast<::evas::common_interface const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::evas::common_interface const*() const { return static_cast<::evas::common_interface const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}

namespace evas {

struct common_interface
      : ::efl::eo::concrete
{
   common_interface(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : common_interface(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit common_interface(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit common_interface(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   common_interface(common_interface const& other)
      : common_interface(eo_ref(other._eo_ptr()))
   {}

   ~common_interface() {}

   /// @brief No description supplied by the EAPI.
   ///
   /// @param ret 
   ///
   Evas * evas_get() const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_COMMON_INTERFACE_INTERFACE);
   }

   struct address_of
      : ::eo_cxx::evas::common_interface::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::evas::common_interface* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::evas::common_interface::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::evas::common_interface const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EVAS_COMMON_INTERFACE_INTERFACE, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::evas::common_interface) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::evas::common_interface>::value, "");

}

inline Evas * evas::common_interface::evas_get() const
{
   Evas * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_common_evas_get());
   return _tmp_ret;
}


inline Evas * eo_cxx::evas::common_interface::evas_get() const
{
   Evas * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_common_evas_get());
   return _tmp_ret;
}


inline ::eo_cxx::evas::common_interface::operator ::evas::common_interface() const
{
   return *static_cast<::evas::common_interface const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas::common_interface::operator ::evas::common_interface&()
{
   return *static_cast<::evas::common_interface*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas::common_interface::operator ::evas::common_interface const&() const
{
   return *static_cast<::evas::common_interface const*>(static_cast<void const*>(this));
}

template <typename T>
Evas * evas_common_interface_evas_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->evas_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas::common_interface >
{
   template <typename T>
   struct type
   {
      virtual Evas * evas_get()
      {
         Evas * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_common_evas_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::evas::common_interface >
{
   static const int value = 1;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas::common_interface>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::evas_common_interface_evas_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_common_evas_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::evas::common_interface >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::evas::common_interface, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::evas::common_interface>)
{
   return (EVAS_COMMON_INTERFACE_INTERFACE);
}

} } }
#endif // EFL_GENERATED_EVAS_COMMON_INTERFACE_HH

